program radiowezel;
{Autor: Micha Bemowski}
{F3:'=' - wypenienie po kolei
 F4:'>' - wypenienie losowe bez powtrze
 R:odwierzenie listy plikw
 usuwanie plikw z dysku?}

uses crt,SBwav,dos,mycrt,dir95;
const
 ilo_b:byte=11;
 max_plikow=1024;
 act=4;
 zaz=1;
type
 czas=record
            h,m,s:byte;
      end;

 TypBlok = record
              start,stop:czas;
              plik:array[1..6]of string[14];
              plik_full:array[1..6]of string[31];
              czas:array[1..6]of word;
              ilosc:byte;
           end;

  Tfile = record
            name:string[14];
            name_full:string[31];
            czas:word;
            used:boolean;
          end;


var
 lista:text;
 s,s2:string;
 key:char;
 num_p,num_b,t_old,t_new,y0,w_old,temp:byte;
 wyb:byte;
 dl,played,before,suma:longint;
 godz,min,sek,sek100,i,il,ilo,fileilo,t1,rand:word;
 filelist:array[1..max_plikow]of Tfile;
 found:FindData;
 harmonogram:file of TypBlok;
 blok:array[1..11]of TypBlok;

procedure splash;
begin
  ClrScr;
  writeln('                                                ');
  writeln('                                                           ');
  writeln('                                                   ');
  writeln('                                                          ');
  writeln('                             v.1.3.0 ');
  writeln('                                                                              ');
  writeln('            /                                                                 ');
  writeln('           /                                                               ');
  writeln('          /                                                                ');
  writeln('         /                                                                ');
  writeln('  ͻ/                                                                 ');
  writeln('                                                                      ');
  writeln('                                                                       ');
  writeln('                                                                  ');
  writeln('                                                                   ');
  writeln('                                            ');
  writeln('                                                          ');
  writeln('                                                              ');
  writeln('                                                                 ');
  writeln('  ͼ\                                                           ');
  writeln('         \                                                    ');
  writeln('          \                                            ');
  writeln('           \                                                  ');
  writeln('            \                                                      ');
end;




function nozero(liczba:byte):string;
var
 s:string;

begin
 str(liczba,s);
 if(liczba=0)then nozero:='00' else
 if(liczba<10)then nozero:='0'+s else nozero:=s;
end;


procedure save_harmonogram;
begin
  assign(harmonogram,'table.dat');
  rewrite(harmonogram);
  for i:=1 to 11 do
  begin
    with(blok[i])do
    begin
      if(i=1)then
      begin
        start.h:=8;start.m:=45;start.s:=0;
        stop.h:=8;stop.m:=55;stop.s:=0;
        ilosc:=4;
      end;

      if(i=2)then
      begin
        start.h:=9;start.m:=40;start.s:=0;
        stop.h:=9;stop.m:=50;stop.s:=0;
        ilosc:=4;
      end;

      if(i=3)then
      begin
        start.h:=10;start.m:=35;start.s:=0;
        stop.h:=10;stop.m:=50;stop.s:=0;
        ilosc:=6;
      end;

      if(i=4)then
      begin
        start.h:=11;start.m:=35;start.s:=0;
        stop.h:=11;stop.m:=40;stop.s:=0;
        ilosc:=2;
      end;

      if(i=5)then
      begin
        start.h:=12;start.m:=25;start.s:=0;
        stop.h:=12;stop.m:=30;stop.s:=0;
        ilosc:=2;
      end;

      if(i=6)then
      begin
        start.h:=13;start.m:=15;start.s:=0;
        stop.h:=13;stop.m:=30;stop.s:=0;
        ilosc:=6;
      end;

      if(i=7)then
      begin
        start.h:=14;start.m:=15;start.s:=0;
        stop.h:=14;stop.m:=20;stop.s:=0;
        ilosc:=2;
      end;

      if(i=8)then
      begin
        start.h:=15;start.m:=5;start.s:=0;
        stop.h:=15;stop.m:=10;stop.s:=0;
        ilosc:=2;
      end;

      if(i=9)then
      begin
        start.h:=15;start.m:=55;start.s:=0;
        stop.h:=16;stop.m:=00;stop.s:=0;
        ilosc:=2;
      end;

      if(i=10)then
      begin
        start.h:=16;start.m:=45;start.s:=0;
        stop.h:=16;stop.m:=50;stop.s:=0;
        ilosc:=2;
      end;

      if(i=11)then
      begin
        start.h:=17;start.m:=35;start.s:=0;
        stop.h:=17;stop.m:=40;stop.s:=0;
        ilosc:=3;
      end;
    end;
    write(harmonogram,blok[i]);
  end;
  close(harmonogram);
end;



procedure load_harmonogram;
begin
  {$I-}
  assign(harmonogram,'table.dat');
  reset(harmonogram);
  if(IOresult<>0)then
  begin
    save_harmonogram;
    assign(harmonogram,'table.dat');
    reset(harmonogram);
  end;
  {$I+}
  seek(harmonogram,0);
  for i:=1 to 11 do read(harmonogram,blok[i]);
  close(harmonogram);
end;




procedure settings;
const
 left=TRUE;
 right=FALSE;
var
 left_poz,right_poz:integer;
 left_page,right_page,files_left,pages:byte;
 side:boolean;
 key:char;

  procedure loadfilelist;
  var
    i,il,first:word;
    tempfile,firstfile:Tfile;

  begin
    for i:=1 to max_plikow do filelist[i].used:=FALSE;
    fileilo:=0;
    FindFirst95('*.wav',$FF,found);
    if(DOSerror=0)then
    repeat
      fileilo:=fileilo+1;
      filelist[fileilo].name:=found.shortfilename;
      s:='';
      for i:=1 to 31 do if(found.fullfilename[i]in[' '..''])then s:=s+found.fullfilename[i];
      filelist[fileilo].name_full:=s;
      filelist[fileilo].czas:=CheckLength(filelist[fileilo].name);
      if(filelist[fileilo].czas=0)or(filelist[fileilo].czas>3600)then fileilo:=fileilo-1
{       else filelist[fileilo].czas:=140};

      for i:=1 to 31 do found.fullfilename[i]:=chr(0);
      for i:=1 to 14 do found.shortfilename[i]:=chr(0);
      FindNext95(found);
    until(DOSerror=18);


    for i:=1 to fileilo-1 do
    begin
      firstfile:=filelist[i];
      first:=1;
      for il:=i to fileilo do
        if(filelist[il].name_full<firstfile.name_full)then
        begin
          firstfile:=filelist[il];
          first:=il;
        end;

      if(first<>1)then
      begin
        tempfile:=filelist[i];
        filelist[i]:=filelist[first];
        filelist[first]:=tempfile;
      end;
    end;

  end;




  procedure write_left(poz,kol:byte);
  begin
    if(poz<=fileilo)then
    begin
      back(kol);
      gotoxy(2,poz-(23*(left_page-1))+1);
      write(filelist[poz].name_full);
      gotoxy(36,poz-(23*(left_page-1))+1);
      write(filelist[poz].czas div 60,':',nozero(filelist[poz].czas mod 60));
      back(0);
    end;
  end;


  procedure clear_left;
  begin
    for i:=1 to 23 do
    begin
      gotoxy(2,i+1);
      write('                                     ');
    end;
    gotoxy(3,25);write(left_page);

    if(fileilo<=23)then files_left:=fileilo;
    if(left_page<((fileilo div 23)+1))then files_left:=23 else files_left:=fileilo-(23*(left_page-1));

    for i:=1 to files_left do
    begin
     gotoxy(2,1+i);
     write(filelist[i+(23*(left_page-1))].name_full);
     gotoxy(36,1+i);
     write(filelist[i+(23*(left_page-1))].czas div 60,':',nozero(filelist[i+(23*(left_page-1))].czas mod 60));
    end;

    if(side=left)then write_left(left_poz,4) else write_left(left_poz,8);
  end;



  procedure write_times;
  var suma:word;
  begin
    txt(0);back(7);
    if(right_page=1)then
    begin
      suma:=0;
      for i:=1 to blok[1].ilosc do suma:=suma+blok[1].czas[i];
      gotoxy(74,2);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[2].ilosc do suma:=suma+blok[2].czas[i];
      gotoxy(74,7);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[3].ilosc do suma:=suma+blok[3].czas[i];
      gotoxy(74,12);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[4].ilosc do suma:=suma+blok[4].czas[i];
      gotoxy(74,19);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[5].ilosc do suma:=suma+blok[5].czas[i];
      gotoxy(74,22);write(nozero(suma div 60),':',nozero(suma mod 60));
    end
    else
    begin
      suma:=0;
      for i:=1 to blok[6].ilosc do suma:=suma+blok[6].czas[i];
      gotoxy(74,2);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[7].ilosc do suma:=suma+blok[7].czas[i];
      gotoxy(74,9);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[8].ilosc do suma:=suma+blok[8].czas[i];
      gotoxy(74,12);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[9].ilosc do suma:=suma+blok[9].czas[i];
      gotoxy(74,15);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[10].ilosc do suma:=suma+blok[10].czas[i];
      gotoxy(74,18);write(nozero(suma div 60),':',nozero(suma mod 60));

      suma:=0;
      for i:=1 to blok[11].ilosc do suma:=suma+blok[11].czas[i];
      gotoxy(74,21);write(nozero(suma div 60),':',nozero(suma mod 60));
    end;
    txt(7);back(0);
  end;


  procedure morning;
  var i:byte;
  begin{morning}
    right_page:=1;
    ClrScr;
  {        00000000011111111112222222222333333333344444444445555555555666666666677777777778
           12345678901234567890123456789012345678901234567890123456789012345678901234567890}
    write('ͻ');
    write('                                       ');txt(0);back(7);write('I przerwa 8:45-8:55 (10min)           ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       3-                                    ');
    write('                                       4-                                    ');
    write('                                       ');txt(0);back(7);write('II przerwa 9:40-9:50 (10min)          ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       3-                                    ');
    write('                                       4-                                    ');
    write('                                       ');txt(0);back(7);write('III przerwa 10:35-10:50 (15min)       ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       3-                                    ');
    write('                                       4-                                    ');
    write('                                       5-                                    ');
    write('                                       6-                                    ');
    write('                                       ');txt(0);back(7);write('IV przerwa 11:35-11:40 (5min)         ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       ');txt(0);back(7);write('V przerwa 12:25-12:30 (5min)          ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('');

    clear_left;
    write_times;


    for i:=1 to 4 do
    begin
      gotoxy(44,i+2);
      write(blok[1].plik_full[i]);
      if(blok[1].plik_full[i]<>'') then
      begin
        gotoxy(76,i+2);
        write(blok[1].czas[i]div 60,':',nozero(blok[1].czas[i]mod 60));
      end;
    end;

    for i:=1 to 4 do
    begin
      gotoxy(44,i+7);
      write(blok[2].plik_full[i]);
      if(blok[2].plik_full[i]<>'') then
      begin
        gotoxy(76,i+7);
        write(blok[2].czas[i]div 60,':',nozero(blok[2].czas[i]mod 60));
      end;
    end;

    for i:=1 to 6 do
    begin
      gotoxy(44,i+12);
      write(blok[3].plik_full[i]);
      if(blok[3].plik_full[i]<>'') then
      begin
        gotoxy(76,i+12);
        write(blok[3].czas[i]div 60,':',nozero(blok[3].czas[i]mod 60));
      end;
    end;

    for i:=1 to 2 do
    begin
      gotoxy(44,i+19);
      write(blok[4].plik_full[i]);
      if(blok[4].plik_full[i]<>'') then
      begin
        gotoxy(76,i+19);
        write(blok[4].czas[i]div 60,':',nozero(blok[4].czas[i]mod 60));
      end;
    end;

    for i:=1 to 2 do
    begin
      gotoxy(44,i+22);
      write(blok[5].plik_full[i]);
      if(blok[5].plik_full[i]<>'') then
      begin
        gotoxy(76,i+22);
        write(blok[5].czas[i]div 60,':',nozero(blok[5].czas[i]mod 60));
      end;
    end;
  end;{morning}



  procedure afternoon;
  var i:byte;
  begin{afternoon}
    right_page:=2;
    ClrScr;
  {          00000000011111111112222222222333333333344444444445555555555666666666677777777778
             12345678901234567890123456789012345678901234567890123456789012345678901234567890}
    write('ͻ');
    write('                                       ');txt(0);back(7);write('VI przerwa 13:15-13:30 (15min)        ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       3-                                    ');
    write('                                       4-                                    ');
    write('                                       5-                                    ');
    write('                                       6-                                    ');
    write('                                       ');txt(0);back(7);write('VII przerwa 14:15-14:20 (5min)        ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       ');txt(0);back(7);write('VIII przerwa 15:05-15:10 (5min)       ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       ');txt(0);back(7);write('IX przerwa 15:55-16:00 (5min)         ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       ');txt(0);back(7);write('X przerwa 16:45-16:50 (5min)          ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       ');txt(0);back(7);write('XI przerwa 17:35-17:40 (5min)         ');
    txt(7);back(0);write('');
    write('                                       1-                                    ');
    write('                                       2-                                    ');
    write('                                       3-                                    ');
    write('');

    clear_left;
    write_times;

    for i:=1 to 6 do
    begin
      gotoxy(44,i+2);
      write(blok[6].plik_full[i]);
      if(blok[6].plik_full[i]<>'') then
      begin
        gotoxy(76,i+2);
        write(blok[6].czas[i]div 60,':',nozero(blok[6].czas[i]mod 60));
      end;
    end;

    for i:=1 to 2 do
    begin
      gotoxy(44,i+9);
      write(blok[7].plik_full[i]);
      if(blok[7].plik_full[i]<>'') then
      begin
        gotoxy(76,i+9);
        write(blok[7].czas[i]div 60,':',nozero(blok[7].czas[i]mod 60));
      end;
    end;

    for i:=1 to 2 do
    begin
      gotoxy(44,i+12);
      write(blok[8].plik_full[i]);
      if(blok[8].plik_full[i]<>'') then
      begin
        gotoxy(76,i+12);
        write(blok[8].czas[i]div 60,':',nozero(blok[8].czas[i]mod 60));
      end;
    end;

    for i:=1 to 2 do
    begin
      gotoxy(44,i+15);
      write(blok[9].plik_full[i]);
      if(blok[9].plik_full[i]<>'') then
      begin
        gotoxy(76,i+15);
        write(blok[9].czas[i]div 60,':',nozero(blok[9].czas[i]mod 60));
      end;
    end;

    for i:=1 to 2 do
    begin
      gotoxy(44,i+18);
      write(blok[10].plik_full[i]);
      if(blok[10].plik_full[i]<>'') then
      begin
        gotoxy(76,i+18);
        write(blok[10].czas[i]div 60,':',nozero(blok[10].czas[i]mod 60));
      end;
    end;

    for i:=1 to 3 do
    begin
      gotoxy(44,i+21);
      write(blok[11].plik_full[i]);
      if(blok[11].plik_full[i]<>'') then
      begin
        gotoxy(76,i+21);
        write(blok[11].czas[i]div 60,':',nozero(blok[11].czas[i]mod 60));
      end;
    end;
  end;{afternoon}


  procedure write_right(poz,kol:byte);
  var i:byte;
  begin
    if(poz>18)and(right_page=1)then
    begin
      afternoon;
      write_left(left_poz,zaz);
    end;
    if(poz<19)and(right_page=2)then
    begin
      morning;
      write_left(left_poz,zaz);
    end;

    if(poz in[1..4])then
    begin
      gotoxy(42,poz+2);back(0);
      write('                                      ');
      gotoxy(42,poz+2);back(kol);
      write(poz,'-',blok[1].plik_full[poz]);
      if(blok[1].plik_full[poz]<>'') then
      begin
        gotoxy(76,poz+2);back(kol);
        write(blok[1].czas[poz]div 60,':',nozero(blok[1].czas[poz]mod 60));
      end;
    end;

    if(poz in[5..8])then
    begin
      gotoxy(42,poz+3);back(0);
      write('                                      ');
      gotoxy(42,poz+3);back(kol);
      write(poz-4,'-');
      write(blok[2].plik_full[poz-4]);
      if(blok[2].plik_full[poz-4]<>'') then
      begin
        gotoxy(76,poz+3);back(kol);
        write(blok[2].czas[poz-4]div 60,':',nozero(blok[2].czas[poz-4]mod 60));
      end;
    end;

    if(poz in[9..14])then
    begin
      gotoxy(42,poz+4);back(0);
      write('                                      ');
      gotoxy(42,poz+4);back(kol);
      write(poz-8,'-');
      write(blok[3].plik_full[poz-8]);
      if(blok[3].plik_full[poz-8]<>'') then
      begin
        gotoxy(76,poz+4);back(kol);
        write(blok[3].czas[poz-8]div 60,':',nozero(blok[3].czas[poz-8]mod 60));
      end;
    end;

    if(poz in[15..16])then
    begin
      gotoxy(42,poz+5);back(0);
      write('                                      ');
      gotoxy(42,poz+5);back(kol);
      write(poz-14,'-');
      write(blok[4].plik_full[poz-14]);
      if(blok[4].plik_full[poz-14]<>'') then
      begin
        gotoxy(76,poz+5);back(kol);
        write(blok[4].czas[poz-14]div 60,':',nozero(blok[4].czas[poz-14]mod 60));
      end;
    end;

    if(poz in[17..18])then
    begin
      gotoxy(42,poz+6);back(0);
      write('                                      ');
      gotoxy(42,poz+6);back(kol);
      write(poz-16,'-');
      write(blok[5].plik_full[poz-16]);
      if(blok[5].plik_full[poz-16]<>'') then
      begin
        gotoxy(76,poz+6);back(kol);
        write(blok[5].czas[poz-16]div 60,':',nozero(blok[5].czas[poz-16]mod 60));
      end;
    end;

    if(poz in[19..24])then
    begin
      gotoxy(42,poz-16);back(0);
      write('                                      ');
      gotoxy(42,poz-16);back(kol);
      write(poz-18,'-');
      write(blok[6].plik_full[poz-18]);
      if(blok[6].plik_full[poz-18]<>'') then
      begin
        gotoxy(76,poz-16);back(kol);
        write(blok[6].czas[poz-18]div 60,':',nozero(blok[6].czas[poz-18]mod 60));
      end;
    end;

    if(poz in[25..26])then
    begin
      gotoxy(42,poz-15);back(0);
      write('                                      ');
      gotoxy(42,poz-15);back(kol);
      write(poz-24,'-');
      write(blok[7].plik_full[poz-24]);
      if(blok[7].plik_full[poz-24]<>'') then
      begin
        gotoxy(76,poz-15);back(kol);
        write(blok[7].czas[poz-24]div 60,':',nozero(blok[7].czas[poz-24]mod 60));
      end;
    end;

    if(poz in[27..28])then
    begin
      gotoxy(42,poz-14);back(0);
      write('                                      ');
      gotoxy(42,poz-14);back(kol);
      write(poz-26,'-');
      write(blok[8].plik_full[poz-26]);
      if(blok[8].plik_full[poz-26]<>'') then
      begin
        gotoxy(76,poz-14);back(kol);
        write(blok[8].czas[poz-26]div 60,':',nozero(blok[8].czas[poz-26]mod 60));
      end;
    end;

    if(poz in[29..30])then
    begin
      gotoxy(42,poz-13);back(0);
      write('                                      ');
      gotoxy(42,poz-13);back(kol);
      write(poz-28,'-');
      write(blok[9].plik_full[poz-28]);
      if(blok[9].plik_full[poz-28]<>'') then
      begin
        gotoxy(76,poz-13);back(kol);
        write(blok[9].czas[poz-28]div 60,':',nozero(blok[9].czas[poz-28]mod 60));
      end;
    end;

    if(poz in[31..32])then
    begin
      gotoxy(42,poz-12);back(0);
      write('                                      ');
      gotoxy(42,poz-12);back(kol);
      write(poz-30,'-');
      write(blok[10].plik_full[poz-30]);
      if(blok[10].plik_full[poz-30]<>'') then
      begin
        gotoxy(76,poz-12);back(kol);
        write(blok[10].czas[poz-30]div 60,':',nozero(blok[10].czas[poz-30]mod 60));
      end;
    end;

    if(poz in[33..35])then
    begin
      gotoxy(42,poz-11);back(0);
      write('                                      ');
      gotoxy(42,poz-11);back(kol);
      write(poz-32,'-');
      write(blok[11].plik_full[poz-32]);
      if(blok[11].plik_full[poz-32]<>'') then
      begin
        gotoxy(76,poz-11);back(kol);
        write(blok[11].czas[poz-32]div 60,':',nozero(blok[11].czas[poz-32]mod 60));
      end;
    end;
    back(0);
  end;


  procedure poz2blok(poz:byte;var b,p:byte);
  begin
    if(poz in[1..4])then
    begin
      b:=1;
      p:=poz;
    end;

    if(poz in[5..8])then
    begin
      b:=2;
      p:=poz-4;
    end;

    if(poz in[9..14])then
    begin
      b:=3;
      p:=poz-8;
    end;

    if(poz in[15..16])then
    begin
      b:=4;
      p:=poz-14;
    end;

    if(poz in[17..18])then
    begin
      b:=5;
      p:=poz-16;
    end;

    if(poz in[19..24])then
    begin
      b:=6;
      p:=poz-18;
    end;

    if(poz in[25..26])then
    begin
      b:=7;
      p:=poz-24;
    end;

    if(poz in[27..28])then
    begin
      b:=8;
      p:=poz-26;
    end;

    if(poz in[29..30])then
    begin
      b:=9;
      p:=poz-28;
    end;

    if(poz in[31..32])then
    begin
      b:=10;
      p:=poz-30;
    end;

    if(poz in[33..35])then
    begin
      b:=11;
      p:=poz-32;
    end;
  end;




begin{settings}
  left_poz:=1;
  right_poz:=1;
  left_page:=1;
  right_page:=1;
  side:=left;
  load_harmonogram;

  ClrScr;
  loadfilelist;
{==================wczytanie listy plikw====================}

  pages:=fileilo div 23;
  if(fileilo mod 23>0)then pages:=pages+1;

  morning;
  write_left(left_poz,act);
  write_right(right_poz,zaz);
  repeat
    key:=' ';
    repeat
     if(keypressed)then key:=readkey;
     if(key=#0)then key:=readkey;
    until(key in[#9,#13,#27,'H','P','S','B','I','Q','=','>','R','r','V','W']);

    if(key in['R','r'])then
    begin
      loadfilelist;
      if(left_page=1)then morning else afternoon;
      if(side=left)then
      begin
        write_right(right_poz,zaz);
        write_left(left_poz,act);
      end
      else
      begin
        write_right(right_poz,act);
        write_left(left_poz,zaz);
      end;
    end;

    if(key=#9)then
      if(side=left)then
      begin
        side:=right;
        write_left(left_poz,zaz);
        write_right(right_poz,act);
      end
      else
      begin
        side:=left;
        write_left(left_poz,act);
        write_right(right_poz,zaz);
      end
    else{if not(key=#9)}
      if(side=left)then
      begin
        if(key='P')and(left_poz<fileilo)then
        begin
          left_poz:=left_poz+1;
          temp:=(left_poz div 23);
          if(left_poz mod 23<>0)then temp:=temp+1;
          if(temp<>left_page)then
          begin
            left_page:=temp;
            clear_left;
            write_left(left_poz,act);
          end
          else
          begin
            write_left(left_poz-1,0);
            write_left(left_poz,act);
          end;
        end;
        if(key='H')and(left_poz>1)then
        begin
          left_poz:=left_poz-1;
          temp:=(left_poz div 23);
          if(left_poz mod 23<>0)then temp:=temp+1;
          if(temp<>left_page)then
          begin
            left_page:=temp;
            clear_left;
            write_left(left_poz,act);
          end
          else
          begin
            write_left(left_poz+1,0);
            write_left(left_poz,act);
          end;
        end;
      end
      else{if(side=rigth)}
      begin
        if(key='P')and(right_poz<35)then
        begin
          right_poz:=right_poz+1;
          write_right(right_poz-1,0);
          write_right(right_poz,act);
        end;
        if(key='H')and(right_poz>1)then
        begin
          right_poz:=right_poz-1;
          write_right(right_poz+1,0);
          write_right(right_poz,act);
        end;
      end;

    if(key=#13)then
    begin
      poz2blok(right_poz,num_b,num_p);
      blok[num_b].plik[num_p]:=filelist[left_poz].name;
      blok[num_b].plik_full[num_p]:=filelist[left_poz].name_full;
      blok[num_b].czas[num_p]:=filelist[left_poz].czas;
      if(side=left)then write_right(right_poz,zaz) else write_right(right_poz,act);
    end;{if(key=#13)}

    if(key='S')and(side=right)then {delete}
    begin
      poz2blok(right_poz,num_b,num_p);
      blok[num_b].plik[num_p]:='';
      blok[num_b].plik_full[num_p]:='';
      blok[num_b].czas[num_p]:=0;
      write_right(right_poz,act);
    end;



    if(key='B')then{delete all}
    begin
      back(6);
      gotoxy(10,11);write('ͻ');
      gotoxy(10,12);write(' Czy na pewno chcesz wyczyci list odtwarzania? (T/N) ');
      gotoxy(10,13);write('ͼ');
      back(0);
      repeat
        if(keypressed)then key:=readkey;
      until(key in['T','t','N','n',#27]);

      if(key in['T','t'])then
      begin
        for i:=1 to 35 do
        begin
          poz2blok(i,num_b,num_p);
          blok[num_b].plik[num_p]:='';
          blok[num_b].plik_full[num_p]:='';
          blok[num_b].czas[num_p]:=0;
        end;
        right_poz:=1;
      end;
      key:=' ';
      morning;
      if(side=left)then
      begin
        write_right(right_poz,zaz);
        write_left(left_poz,act);
      end
      else
      begin
        write_right(right_poz,act);
        write_left(left_poz,zaz);
      end;
    end;

    if(key='Q')and(side=left)and(left_page<pages)then
    begin
      left_page:=left_page+1;
      if(left_poz+23<fileilo)then left_poz:=left_poz+23 else left_poz:=fileilo;
      clear_left;
    end;

    if(key='I')and(side=left)and(left_page>1)then
    begin
      left_page:=left_page-1;
      left_poz:=left_poz-23;
      clear_left;
    end;

    poz2blok(right_poz,num_b,num_p);

    if(key='I')and(side=right)and(num_p>1)then
    begin
      s:=blok[num_b].plik[num_p-1];
      s2:=blok[num_b].plik_full[num_p-1];
      t1:=blok[num_b].czas[num_p-1];

      blok[num_b].plik[num_p-1]:=blok[num_b].plik[num_p];
      blok[num_b].plik_full[num_p-1]:=blok[num_b].plik_full[num_p];
      blok[num_b].czas[num_p-1]:=blok[num_b].czas[num_p];

      blok[num_b].plik[num_p]:=s;
      blok[num_b].plik_full[num_p]:=s2;
      blok[num_b].czas[num_p]:=t1;

      right_poz:=right_poz-1;
      write_right(right_poz+1,0);
      write_right(right_poz,act);
    end;

    if(key='Q')and(side=right)and(num_p<blok[num_b].ilosc)then
    begin
      s:=blok[num_b].plik[num_p+1];
      s2:=blok[num_b].plik_full[num_p+1];
      t1:=blok[num_b].czas[num_p+1];

      blok[num_b].plik[num_p+1]:=blok[num_b].plik[num_p];
      blok[num_b].plik_full[num_p+1]:=blok[num_b].plik_full[num_p];
      blok[num_b].czas[num_p+1]:=blok[num_b].czas[num_p];

      blok[num_b].plik[num_p]:=s;
      blok[num_b].plik_full[num_p]:=s2;
      blok[num_b].czas[num_p]:=t1;

      right_poz:=right_poz+1;
      write_right(right_poz-1,0);
      write_right(right_poz,act);
    end;


    if(key='=')then{wypelnienie po kolei}
    begin
      for i:=right_poz+1 to right_poz+fileilo-left_poz+1 do
      if((i-1)<=35)then
      begin
        poz2blok(i-1,num_b,num_p);
        blok[num_b].plik[num_p]:=filelist[i-right_poz+left_poz-1].name;
        blok[num_b].plik_full[num_p]:=filelist[i-right_poz+left_poz-1].name_full;
        blok[num_b].czas[num_p]:=filelist[i-right_poz+left_poz-1].czas;
      end;
      if(right_page=1)then morning else afternoon;
      if(side=left)then
      begin
        write_right(right_poz,zaz);
        write_left(left_poz,act);
      end
      else
      begin
        write_right(right_poz,act);
        write_left(left_poz,zaz);
      end;
    end;


    if(key='>')then{wypelnienie losowe}
    begin
      randomize;
      for i:=right_poz+1 to right_poz+fileilo-left_poz+1 do
      if((i-1)<=35)then
      begin
        repeat
          rand:=random(fileilo-left_poz+1);
          rand:=rand+left_poz;
        until filelist[rand].used=FALSE;
        filelist[rand].used:=TRUE;
        poz2blok(i-1,num_b,num_p);
        blok[num_b].plik[num_p]:=filelist[rand].name;
        blok[num_b].plik_full[num_p]:=filelist[rand].name_full;
        blok[num_b].czas[num_p]:=filelist[rand].czas;
      end;
      if(right_page=1)then morning else afternoon;
      if(side=left)then
      begin
        write_right(right_poz,zaz);
        write_left(left_poz,act);
      end
      else
      begin
        write_right(right_poz,act);
        write_left(left_poz,zaz);
      end;
      for i:=1 to max_plikow do filelist[i].used:=FALSE;
    end;


    if(key='V')then{wypelnienie po kolei do maks czasu}
    begin
      i:=right_poz;{prawa}
      il:=left_poz;{lewa}
      repeat
        poz2blok(i,num_b,num_p);
        blok[num_b].czas[num_p]:=0;
        suma:=0;
        for ilo:=1 to num_p do suma:=suma+blok[num_b].czas[ilo];
        if(blok[num_b].ilosc*150>suma)then
        begin
          blok[num_b].plik[num_p]:=filelist[il].name;
          blok[num_b].plik_full[num_p]:=filelist[il].name_full;
          blok[num_b].czas[num_p]:=filelist[il].czas;
          il:=il+1
        end
        else
        begin
          blok[num_b].plik[num_p]:='';
          blok[num_b].plik_full[num_p]:='';
          blok[num_b].czas[num_p]:=0;
        end;
        i:=i+1;
      until(il=fileilo+1)or(i=36);

      if(right_page=1)then morning else afternoon;
      if(side=left)then
      begin
        write_right(right_poz,zaz);
        write_left(left_poz,act);
      end
      else
      begin
        write_right(right_poz,act);
        write_left(left_poz,zaz);
      end;
    end;



    if(key='W')then{wypelnienie losowe do maks czasu}
    begin
      randomize;
      i:=right_poz;{prawa}
      il:=left_poz;{lewa}
      repeat
        repeat
          rand:=random(fileilo-left_poz+1);
          rand:=rand+left_poz;
        until filelist[rand].used=FALSE;
        poz2blok(i,num_b,num_p);
        blok[num_b].czas[num_p]:=0;
        suma:=0;
        for ilo:=1 to num_p do suma:=suma+blok[num_b].czas[ilo];
        if(blok[num_b].ilosc*150>suma)then
        begin
          blok[num_b].plik[num_p]:=filelist[rand].name;
          blok[num_b].plik_full[num_p]:=filelist[rand].name_full;
          blok[num_b].czas[num_p]:=filelist[rand].czas;
          filelist[rand].used:=TRUE;
          il:=il+1
        end
        else
        begin
          blok[num_b].plik[num_p]:='';
          blok[num_b].plik_full[num_p]:='';
          blok[num_b].czas[num_p]:=0;
        end;
        i:=i+1;
      until(il=fileilo+1)or(i=36);



      if(right_page=1)then morning else afternoon;
      if(side=left)then
      begin
        write_right(right_poz,zaz);
        write_left(left_poz,act);
      end
      else
      begin
        write_right(right_poz,act);
        write_left(left_poz,zaz);
      end;
      for i:=1 to max_plikow do filelist[i].used:=FALSE;
    end;






    if(key in[#13,'S','=','>'])then write_times;

  until(key=#27);

  save_harmonogram;
end;{settings}



procedure play;
var
 key:char;
 first:string;

begin
 ClrScr;
 load_harmonogram;

 GetTime(godz,min,sek,sek100);

 SBopen;
 if(not SBfound)then
 begin
  writeln('Brak karty dwikowej!');
  readln;
  exit; {----------mona wyczy do testw-------}
 end;

 for num_b:=1 to ilo_b do
  with blok[num_b] do
   if((start.h>godz)
   or((start.h=godz)and(start.m>min))
   or((start.h=godz)and(start.m=min)and(start.s>=sek)))
   or((start.h<godz)
   or((start.h=godz)and(start.m<min))
   or((start.h=godz)and(start.m=min)and(start.s<=sek)))
   and((stop.h>godz)
   or((stop.h=godz)and(stop.m>min))
   or((stop.h=godz)and(stop.m=min)and(stop.s>=sek)))
   then
   begin
    ClrScr;
    writeln(nozero(start.h),':',nozero(start.m),':',nozero(start.s));
    for i:=1 to blok[num_b].ilosc do
    begin
      write('Plik ',i,': ',plik_full[i]);
      gotoxy(45,WhereY);write(czas[i]div 60,':',nozero(czas[i]mod 60));
      gotoxy(50,WhereY);writeln(plik[i]);
    end;
    writeln(nozero(stop.h),':',nozero(stop.m),':',nozero(stop.s));
    writeln;

    for i:=ilosc downto 1 do if(plik[i]<>'')then first:=plik_full[i];
    writeln('Nastpna piosenka: ',first,' Start o: ',nozero(start.h),':',nozero(start.m),':',nozero(start.s));

    if((start.h>godz)
    or((start.h=godz)and(start.m>min))
    or((start.h=godz)and(start.m=min)and(start.s>=sek)))
    then
    repeat
      GetTime(godz,min,sek,sek100);
      gotoxy(1,WhereY);write(nozero(godz),':',nozero(min),':',nozero(sek));
      if(keypressed)then key:=readkey;
    until(start.h<=godz)and(start.m<=min)and(start.s<=sek)or(key=#27);
    if(key=#27)then exit;
    num_p:=0;

    writeln;
    writeln;
    y0:=WhereY;
    dl:=1;
    repeat
     num_p:=num_p+1;
     if(plik[num_p]<>'')then
     begin
       SBplay(plik[num_p]);
       dl:=SBlength;
     end;

     gotoxy(1,y0);
     for i:=1 to 240 do write(' ');
     gotoxy(1,y0);
     writeln('Odtwarzanie: ',plik_full[num_p],'  Czas: ',nozero(trunc(dl/60)),':',nozero(dl mod 60));

     t_old:=sek;
     played:=0;
     w_old:=0;

     key:=' ';
     repeat
      GetTime(godz,min,sek,sek100);
      if(keypressed)then
      begin
       key:=readkey;
       if(key=#0)then key:=readkey;
      end;
      if(t_old<>sek)then
      begin
       t_old:=sek;
       played:=played+1;
      end;
      gotoxy(1,y0+2);
      write('-',nozero(trunc((dl-played)/60)),':',nozero((dl-played)mod 60));
      if(dl<>0)then
      if(trunc((played/dl)*80)>w_old)then
      begin
       w_old:=trunc((played/dl)*80);
       gotoxy(1,y0+1);
       for i:=1 to w_old do write('');
      end;
      gotoxy(1,y0);

      delay(500);
     until(SBplaying=false)or(stop.h<godz)or((stop.h=godz)and(stop.m<min))
          or((stop.h=godz)and(stop.m=min)and(stop.s<=sek))or(key=#27)or(key='M');

     SBstop;

{     if(WaveError=1)then writeln('Nie znaleziono pliku!');
     if(WaveError=2)then writeln('Nieprawidowy plik WAVE');
     if(WaveError=3)then writeln('Brak karty dwikowej');
     if(WaveError=4)then writeln('Brak karty stereo');
     if(WaveError=5)then writeln('Brak karty dwikowej 16bit');
     if(WaveError=6)then writeln('Brak pamici');}

    until((SBplaying=false)and(num_p=ilosc))or(stop.h<godz)or((stop.h=godz)and(stop.m<min))
         or((stop.h=godz)and(stop.m=min)and(stop.s<=sek))or(key=#27)or(num_p=ilosc);

 end;

 SBclose;
end;




begin
{  fileilo:=253;
  for i:=1 to 253 do
  begin
    str(i,s);
    filelist[i].name_full:='long file name'+s+'.wav';
  end;}

  splash;
  repeat until keypressed;
  key:=readkey;

  repeat
    ClrScr;
    key:=' ';
    wyb:=1;
    writeln('Radiowze v.1.3.0');
    writeln;
    back(act);writeln('1.Ustawienia harmonogramu');back(0);
    writeln('2.Odtwarzanie muzyki');
    writeln('3.Koniec');
    gotoxy(1,19);
    writeln('Klawiszologia:');
    writeln('F3 -  wypenienie harmonogramu po kolei (+Shift - z ograniczeniem czasu)');
    writeln('F4 -  wypenienie harmonogramu losowo (+Shift - z ograniczeniem czasu)');
    writeln('F8 -  wyczyszczenie harmonogramu');
    writeln('R  -  odwierzenie listy plikw');
    gotoxy(1,25);write('Copyrights Micha Bemowski 2008 michal_bemowski@wp.pl');

    repeat
      key:=' ';
      repeat
        key:=readkey;
        if(key=#0)then key:=readkey;
      until(key=#13)or(key='H')or(key='P');

      if(key='P')and(wyb<3)then
      begin
        if(wyb=1)then
        begin
          gotoxy(1,3);
          write('1.Ustawienia harmonogramu');
        end;
        if(wyb=2)then
        begin
          gotoxy(1,4);
          write('2.Odtwarzanie muzyki');
        end;
        wyb:=wyb+1;
        if(wyb=2)then
        begin
          gotoxy(1,4);
          back(act);write('2.Odtwarzanie muzyki');back(0);
        end;
        if(wyb=3)then
        begin
          gotoxy(1,5);
          back(act);write('3.Koniec');back(0);
        end;
      end;

      if(key='H')and(wyb>1)then
      begin
        if(wyb=2)then
        begin
          gotoxy(1,4);
          write('2.Odtwarzanie muzyki');
        end;
        if(wyb=3)then
        begin
          gotoxy(1,5);
          write('3.Koniec');
        end;
        wyb:=wyb-1;
        if(wyb=1)then
        begin
          gotoxy(1,3);
          back(act);write('1.Ustawienia harmonogramu');back(0);
        end;
        if(wyb=2)then
        begin
          gotoxy(1,4);
          back(act);write('2.Odtwarzanie muzyki');back(0);
        end;
      end;

      if(key=#13)and(wyb=1)then settings;

      if(key=#13)and(wyb=2)then play;

    until(key=#13);
  until(wyb=3)and(key=#13);

end.